#include<bits/stdc++.h>
using namespace std;
int o,a,b,ab,n,t[10^6];
int ulO[10^6], ulA[10^6], ulB[10^6], ulAB[10^6];
int izO[10^6], izA[10^6], izB[10^6], izAB[10^6];
string pacijenti[10^6];
int pojedinacna_kol[10^6];
int zbira, zbirab, zbirb, zbiro;
int main()
{
  zbiro=0;
  zbira=0;
  zbirb=0;
  zbirab=0;

  cin >> n;
  cin >> o >> a >> b >> ab;
  for(int i=0; i<n; i++)
  {
    cin >> pacijenti[i] >> t[i];

    if(pacijenti[i]=="O")
    {
      zbiro=zbiro+t[i];
    }

    if(pacijenti[i]=="A")
    {
      zbira=zbira+t[i];
    }

      if(pacijenti[i]=="B")
    {
      zbirb=zbirb+t[i];
    }

      if(pacijenti[i]=="AB")
    {
      zbirab=zbirab+t[i];
    }
  }
  if(zbiro>o)
  {
    cout << "nemoguce" << endl;
    return 0;
  }
  o=o-zbiro;


  if(a-zbira<0)
  {
    if((a+o)-zbira<0 )//a je kolko imam zbira kolko treba
    {
      cout << "nemoguce" << endl;
      o=o-a-zbira;
      zbira=zbira-a;
      return 0;
    }
  }
  zbira=zbira-a;



  if(b-zbirb<0)
  {
    if((b+o)-zbirb<0 )//a je kolko imam zbira kolko treba
    {
      cout << "nemoguce" << endl;
      o=o-(b-zbirb);
      zbirb=zbirb-b;
      return 0;
    }
  }
  zbirb=zbirb-b;


  if((ab+a+b+o)-zbirab<0)
  {
    cout << "nemoguce" << endl;
    return 0;
  }
  else
  {
    cout << "moguce" << endl;

        for(int i=1; i<=n; i++)
        {
          if(pacijenti[i]=="O")
          {
            cout << t[i] << " 0 0 0" << endl;
            zbiro=zbiro-t[i];
          }
          if(pacijenti[i]=="A")
          {
            if(a > zbira)
            {
              cout << zbiro-(t[i]-zbira) << " " << t[i]-zbira << " 0 0" << endl;
              zbiro=zbiro-abs(zbira-t[i]);
              zbira=abs(t[i]-zbira);
            }
            else
            {
              cout << "0 0 " << t[i] << " 0" << endl;
              zbira=abs(t[i]-zbira);
            }
          }

          if(pacijenti[i]=="B")
          {
            if(b>zbirb)
            {
              cout << zbiro-(t[i]-zbirb) << " 0 " << t[i]-zbirb << " 0" << endl;
              zbiro=zbiro-abs(zbirb-t[i]);
              zbirb=abs(t[i]-zbirb);
            }
            else
            {
              cout << "0 0 " << t[i] << " 0" << endl;
              zbirb=abs(t[i]-zbirb);
            }
          }

          if(pacijenti[i]=="AB")
            {
              if(ab<zbirab)
              {
                cout << zbiro-(t[i]-zbirab) <<" " << zbira-(t[i]-zbirab) << " " << zbirb-(t[i]-zbirab) << " " << zbirab-(t[i]-zbirab) << endl;
              }
              else
              {
                cout << "0 0 0 " << t[i];
              }
            }
        }

  }
  return 0;
}